"{ Package: 'exept:regression' }"

LibraryDefinition subclass:#exept_regression
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!exept_regression class methodsFor:'accessing - tests'!

testCaseNamesWithoutNamespace
    ^#(
     "/ 'SunitXMLOutputTest'
    'CoverageInstrumentationTest'
    'AssociationTests'
    'BinaryIOTests'
    'BinaryTreeTester'
    "/ 'BlockTest'
    'CharacterTests'
    'CollectionTests'
    'CompilerTest'
    'ComplexTest'
    'STCCompilerTests'
    "/ 'DebuggerTest'
    "/ 'DeepCopyTests'
    'DelayTest'
    'DictionaryTest'
    'EnumerationTests'
    'ExceptionTest'
    "/ 'ExternalInterfaceTests'
    "/ 'FileOpenTest'
    'FileStreamTest'
    'FloatTest'
    'FractionTest'
    "/ 'GCTest'
    "/ 'GraphicDrawingTest'
    "/ 'HTMLParserTests'
    "/ 'ImageReaderTest'
    'IntegerTest'
    'JavaScriptTests'
    "/ 'MeasurementValueTests'
    "/ 'MemoryTest'
    'NumberTest'
    "/ 'ParserTest'
    'ScaledDecimalTest'
    "/ 'SemaphoreTest'
    "/ 'SharedQueueTest'
    'SmallIntegerTest'
    "/ 'SortTests'
    'StringTests'
    'StreamTests'
    'TimeAndDateTest'
    'TimeDurationTest'
    "/ 'URLTest'
    "/ 'XMLCoderTests'
    "/ 'ZipArchiveTests'
    'ClassBuilderTests'
    'CompilerTests2'
    'ChangeSetTests'
    'FilenameTests'
    'ProjectDefinitionTests'
    'ClassDescriptionTests'
    'SnapshotRestartTests'
    'MakefileTests'
    'TSTreeTests'
    'TSMultiTreeTests'
    )

    "Modified: / 26-04-2014 / 12:20:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

testSuite

    | suite |

    suite := TestSuite named: self package.    
    self testCaseNamesWithoutNamespace do:[:className |
        |fullName|

        fullName := ('RegressionTests::',className).
        ('Loading ',className,'...') infoPrintCR.
        Smalltalk fileInClass:fullName package:self package.
        (Smalltalk classNamed:fullName) isNil ifTrue:[
            ('**** Ouch - missing class: "',fullName,'"') infoPrintCR.
        ] ifFalse:[
            suite addTest:(Smalltalk classNamed:fullName) suite.
        ].
    ].

    ^suite

    "Created: / 03-08-2011 / 09:19:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!exept_regression class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'exept:libcrypt'    "loaded lazily by CryptTests - SHA256Stream - referenced by RegressionTests::CryptTests>>test06_sha256 "
        #'stx:goodies'    "no project def - CharacterEncoderCodeGenerator - referenced by RegressionTests::CharacterTests>>test01CaseTesting "
    )

    "Modified: / 03-03-2014 / 12:00:16 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

mandatoryPreRequisites
    "list all required mandatory packages.
     Packages are mandatory, if they contain superclasses of the package's classes
     or classes which are extended by this package.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies
     (the browser has a menu function for that)
     However, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPreRequisites method."

    ^ #(
        #'stx:goodies/sunit'    "TestAsserter - superclass of RegressionTests::BinaryTreeTester "
        #'stx:libbasic'    "Notification - superclass of RegressionTests::ContextTest2::MyNotification "
        #'stx:libview'    "GraphicsMedium - superclass of RegressionTests::WrongMethodCalledTest::GraphicTestView "
        #'stx:libview2'    "Model - superclass of RegressionTests::LabelResizingTest "
    )
!

referencedPreRequisites
    "list all packages containing classes referenced by the packages's members.
     This list can be maintained manually or (better) generated and
     updated by looking for global variable accesses
     (the browser has a menu function for that)
     However, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPreRequisites method."

    ^ #(
        #'stx:goodies/webServer/htmlTree'    "HTML::HTMLParser - referenced by RegressionTests::HTMLParserTests>>test02 "
        #'stx:goodies/xml/stx'    "XMLStandardDecoder - referenced by RegressionTests::XMLCoderTests>>encodeAndDecode: "
        #'stx:goodies/xml/vw'    "XML::Attribute - referenced by RegressionTests::MemoryTest>>test1 "
        #'stx:libbasic2'    "HostNameLookupError - referenced by RegressionTests::SocketTests>>test11_concurrentOpenClose "
        #'stx:libbasic3'    "ChangeSet - referenced by RegressionTests::ChangeSetTests>>test_ClassDefinitionChange_05e "
        #'stx:libboss'    "BinaryObjectStorage - referenced by RegressionTests::BinaryIOTests>>testSaveReadBOS "
        #'stx:libcomp'    "ParserFlags - referenced by RegressionTests::CompilerTest>>test_bad_return2 "
        #'stx:libcompat'    "ExternalReadStream - referenced by RegressionTests::ExternalStreamTest>>testRead2 "
        #'stx:libhtml'    "URL - referenced by RegressionTests::URLTest>>test02_construct "
        #'stx:libjavascript'    "JavaScriptParser - referenced by RegressionTests::JavaScriptTests>>doTestEachFromSpec: "
        #'stx:libtool'    "WorkspaceApplication - referenced by RegressionTests::CompilerTests2>>test_01 "
        #'stx:libwidg'    "Button - referenced by RegressionTests::UTF8TestClass>>someJapaneseButton "
        #'stx:libwidg2'    "HierarchicalItem - referenced by RegressionTests::BinaryIOTests>>testSaveReadBOS "
    )

    "Modified: / 03-03-2014 / 11:59:44 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
    )
! !

!exept_regression class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        (#'RegressionTests::AssociationTests' autoload)
        (#'RegressionTests::BinaryIOTests' autoload)
        (#'RegressionTests::BinaryTreeTester' autoload)
        #'RegressionTests::CECollectionExtensionTest'
        #'RegressionTests::CESequenceableCollectionExtensionTest'
        #'RegressionTests::CEStringExtensionTest'
        (#'RegressionTests::CharacterTests' autoload)
        (#'RegressionTests::ClassAndMethodCompilingTestCase' autoload)
        (#'RegressionTests::ClassDescriptionTests' autoload)
        (#'RegressionTests::CollectionTests' autoload)
        (#'RegressionTests::CompilerTest' autoload)
        (#'RegressionTests::CompilerTests2' autoload)
        (#'RegressionTests::ComplexTest' autoload)
        (#'RegressionTests::CoverageInstrumentationTest' autoload)
        (#'RegressionTests::DelayTest' autoload)
        (#'RegressionTests::DictionaryTest' autoload)
        (#'RegressionTests::EnumerationTests' autoload)
        (#'RegressionTests::ExceptionTest' autoload)
        (#'RegressionTests::FileStreamTest' autoload)
        (#'RegressionTests::FilenameTests' autoload)
        (#'RegressionTests::FloatTest' autoload)
        (#'RegressionTests::FractionTest' autoload)
        (#'RegressionTests::IntegerTest' autoload)
        (#'RegressionTests::JavaScriptTests' autoload)
        (#'RegressionTests::MakefileTests' autoload)
        (#'RegressionTests::NumberTest' autoload)
        (#'RegressionTests::ProjectDefinitionTests' autoload)
        (#'RegressionTests::STCCompilerTests' autoload)
        (#'RegressionTests::ScaledDecimalTest' autoload)
        (#'RegressionTests::SmallIntegerTest' autoload)
        (#'RegressionTests::SnapshotRestartTests' autoload)
        (#'RegressionTests::StreamTests' autoload)
        (#'RegressionTests::StringTests' autoload)
        (#'RegressionTests::TSTreeTests' autoload)
        (#'RegressionTests::TimeAndDateTest' autoload)
        (#'RegressionTests::TimeDurationTest' autoload)
        #'exept_regression'
        (#'RegressionTests::ChangeSetTests' autoload)
        (#'RegressionTests::ClassBuilderTests' autoload)
        (#'RegressionTests::TSMultiTreeTests' autoload)
        (#'RegressionTests::UninterpretedBytesTest' autoload)
        (#'RegressionTests::CharacterSetTests' autoload)
        (#'RegressionTests::LargeFloatTest' autoload)
        (#'RegressionTests::LoggedStreamTests' autoload)
        (#'RegressionTests::MetaNumbersTest' autoload)
        (#'RegressionTests::PTYTest' autoload)
        (#'RegressionTests::ParserTests' autoload)
        (#'RegressionTests::PipeStreamTest' autoload)
        (#'RegressionTests::PowerSetTests' autoload)
        (#'RegressionTests::QueueTest' autoload)
        (#'RegressionTests::SegmentedOrderedCollectionTests' autoload)
        (#'RegressionTests::ServerSocketTest' autoload)
        (#'RegressionTests::SharedQueueTest' autoload)
        (#'RegressionTests::SocketTests' autoload)
        (#'RegressionTests::SortTests' autoload)
        (#'RegressionTests::WeakCollectionTest' autoload)
        (#'RegressionTests::BecomeTests' autoload)
        (#'RegressionTests::BehaviorLookupObjectTests' autoload)
        (#'RegressionTests::BlockTest' autoload)
        (#'RegressionTests::CharacterEncoderTests' autoload)
        (#'RegressionTests::ClassWithoutVersionMethod' autoload)
        (#'RegressionTests::ContextTest2' autoload)
        (#'RegressionTests::DebuggerTest' autoload)
        (#'RegressionTests::DeepCopyTests' autoload)
        (#'RegressionTests::DoubleMetaphoneStringComparatorTest' autoload)
        (#'RegressionTests::ExternalInterfaceTests' autoload)
        (#'RegressionTests::ExternalStreamTest' autoload)
        (#'RegressionTests::FileOpenTest' autoload)
        (#'RegressionTests::GCTest' autoload)
        (#'RegressionTests::GraphicDrawingTest' autoload)
        (#'RegressionTests::HTMLParserTests' autoload)
        (#'RegressionTests::ImageReaderTest' autoload)
        (#'RegressionTests::JITTest' autoload)
        (#'RegressionTests::KoelnerPhoneticCodeStringComparatorTest' autoload)
        (#'RegressionTests::LabelResizingTest' autoload)
        (#'RegressionTests::ManyProcessesTest' autoload)
        (#'RegressionTests::MeasurementValueTests' autoload)
        (#'RegressionTests::MemoryTest' autoload)
        (#'RegressionTests::MiracodeStringComparatorTest' autoload)
        (#'RegressionTests::MySQLSoundexStringComparatorTest' autoload)
        (#'RegressionTests::OS_OLE_Tests' autoload)
        (#'RegressionTests::OperatingSystemTest' autoload)
        (#'RegressionTests::OperationInQueueTests' autoload)
        (#'RegressionTests::ProcessTest' autoload)
        (#'RegressionTests::SelectorNamespacesTests' autoload)
        (#'RegressionTests::SemaphoreTest' autoload)
        (#'RegressionTests::SoundexStringComparatorTest' autoload)
        (#'RegressionTests::StackFrameTest' autoload)
        (#'RegressionTests::TestDialogs1' autoload)
        (#'RegressionTests::URLTest' autoload)
        (#'RegressionTests::UTF8TestClass' autoload)
        (#'RegressionTests::Win32OperatingSystemTest' autoload)
        (#'RegressionTests::WrongMethodCalledTest' autoload)
        (#'RegressionTests::XMLCoderTests' autoload)
        (#'RegressionTests::ZipArchiveTests' autoload)
        (#'RegressionTests::LiteralsInMethodTests' autoload)
        (#'RegressionTests::WritingToTranscriptOrStdoutTest' autoload)
        (#'RegressionTests::SunitXMLOutputTest' autoload)
        (#'RegressionTests::CachedValueTest' autoload)
        (#'RegressionTests::QuickTestRunner' autoload)
        (#'RegressionTests::CryptTests' autoload)
        (#'RegressionTests::BreakpointTests' autoload)
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!exept_regression class methodsFor:'description - project information'!

applicationIconFileName
    "Return the name (without suffix) of an icon-file (the app's icon); will be included in the rc-resource file"

    ^ nil
    "/ ^ self applicationName
!

companyName
    "Return a companyname which will appear in <lib>.rc"

    ^ 'eXept Software AG'
!

description
    "Return a description string which will appear in vc.def / bc.def"

    ^ 'Class Library'
!

legalCopyright
    "Return a copyright string which will appear in <lib>.rc"

    ^ 'Copyright eXept Software AG 1998-2011'
!

productName
    "Return a product name which will appear in <lib>.rc"

    ^ 'eXept addOns'
! !

!exept_regression class methodsFor:'documentation'!

version
    ^ '$Header$'
!

version_CVS
    ^ '$Header$'
! !

